import { isVue3 as y, h as d, computed as N, defineComponent as M, ref as C, watch as Q, onMounted as ze, onBeforeUnmount as Be, Vue2 as Le } from "vue-demi";
import { createListenerPropsForwarder as q, pick as h, withDefaultProps as H, isObject as ye, isHandlerKey as ke, toListenerKey as Ke, useListeners as Me, isString as $e, normalizeListenerKeys as R, mergeProps as A, isDef as qe, isFunction as k } from "@visoning/vue-utility";
import { FloatingCreatorProps as be, useManualEffect as He, FloatingCreator as X } from "@visoning/vue-floating-core";
import { InteractorProps as Ge, createInteractorForwardContext as Je, useInteractorForwardContext as Qe, Interactor as Y } from "@visoning/vue-floating-interactions";
import { createInteractorForwardContext as nr, useInteractorForwardContext as ar } from "@visoning/vue-floating-interactions";
import { offset as Xe, shift as Ye, flip as Ze, autoPlacement as et, arrow as tt } from "@floating-ui/core";
var rt = Object.defineProperty, ot = Object.defineProperties, nt = Object.getOwnPropertyDescriptors, Z = Object.getOwnPropertySymbols, at = Object.prototype.hasOwnProperty, st = Object.prototype.propertyIsEnumerable, ee = (e, t, r) => t in e ? rt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, U = (e, t) => {
  for (var r in t || (t = {}))
    at.call(t, r) && ee(e, r, t[r]);
  if (Z)
    for (var r of Z(t))
      st.call(t, r) && ee(e, r, t[r]);
  return e;
}, lt = (e, t) => ot(e, nt(t));
const he = q(be, ["onFloatingDataUpdate"]), it = h(be, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
]), je = h(Ge, [
  "interactions",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside"
]), xe = {
  delay: [Number, Object],
  hoverDelay: [Number, Object],
  clickDelay: [Number, Object],
  focusDelay: [Number, Object]
}, pt = (e) => Object.keys(e).reduce((t, r) => {
  const a = e[r];
  return t[r] = ye(a) ? { active: a.open, inactive: a.close } : a, t;
}, {}), ct = lt(U(U(U(U({}, it), he.props), je), xe), {
  open: Boolean,
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {},
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: [Boolean, Object],
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  floatingProps: Object,
  floatingWrapper: Function,
  popupProps: Object,
  popupWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function
}), ut = {
  open: void 0,
  defaultOpen: !1,
  shift: !0,
  appendTo: "body"
}, G = H(ct, ut);
var dt = Object.defineProperty, ft = Object.defineProperties, vt = Object.getOwnPropertyDescriptors, V = Object.getOwnPropertySymbols, De = Object.prototype.hasOwnProperty, Ee = Object.prototype.propertyIsEnumerable, te = (e, t, r) => t in e ? dt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, B = (e, t) => {
  for (var r in t || (t = {}))
    De.call(t, r) && te(e, r, t[r]);
  if (V)
    for (var r of V(t))
      Ee.call(t, r) && te(e, r, t[r]);
  return e;
}, Pt = (e, t) => ft(e, vt(t)), _t = (e, t) => {
  var r = {};
  for (var a in e)
    De.call(e, a) && t.indexOf(a) < 0 && (r[a] = e[a]);
  if (e != null && V)
    for (var a of V(e))
      t.indexOf(a) < 0 && Ee.call(e, a) && (r[a] = e[a]);
  return r;
};
function z(e, t, r) {
  if (r = Array.isArray(r) ? r : [r], y)
    return d(e, t.data, t.scopedSlots ? Pt(B({}, t.scopedSlots), {
      default: (...s) => {
        var c, _;
        return r.concat((_ = (c = t.scopedSlots) == null ? void 0 : c.default) == null ? void 0 : _.call(c, ...s));
      }
    }) : r);
  const a = t.data, {
    key: P,
    ref: $,
    class: b,
    style: i,
    scopedSlots: m
  } = a, p = _t(a, [
    "key",
    "ref",
    "class",
    "style",
    "scopedSlots"
  ]), O = {}, S = {}, o = {}, { propKeys: l } = t;
  for (const s in p)
    ke(s) ? O[Ke(s)] = p[s] : l != null && l.includes(s) ? o[s] = p[s] : S[s] = p[s];
  return d(e, {
    key: P,
    ref: $,
    class: b,
    style: i,
    props: o,
    attrs: S,
    on: O,
    scopedSlots: B(B({}, m), t.scopedSlots)
  }, r);
}
let Ce, Se, Fe, K;
try {
  const e = require("vue");
  Ce = e.Transition, Se = e.Teleport, Fe = e.vShow, K = e.withDirectives;
} catch {
}
function mt(e) {
  return N(() => {
    const t = [];
    return e.offset && t.push(Xe(e.offset)), e.shift && t.push(Ye(L(e.shift))), e.flip && t.push(Ze(L(e.flip))), e.autoPlacement && t.push(et(L(e.autoPlacement))), t.concat(e.middleware || []);
  });
}
function L(e, t = {}) {
  return ye(e) ? e : t;
}
var Ot = Object.defineProperty, gt = Object.defineProperties, wt = Object.getOwnPropertyDescriptors, re = Object.getOwnPropertySymbols, yt = Object.prototype.hasOwnProperty, $t = Object.prototype.propertyIsEnumerable, oe = (e, t, r) => t in e ? Ot(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, w = (e, t) => {
  for (var r in t || (t = {}))
    yt.call(t, r) && oe(e, r, t[r]);
  if (re)
    for (var r of re(t))
      $t.call(t, r) && oe(e, r, t[r]);
  return e;
}, ne = (e, t) => gt(e, wt(t));
const ae = {
  floating: "visoning-floating",
  popup: "visoning-popup"
}, se = M({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: G,
  setup(e, { slots: t, attrs: r, expose: a }) {
    const P = C(!!e.defaultOpen), $ = N(() => e.open === void 0 ? P.value : e.open), b = Me(), i = (n, v) => {
      P.value = n, n !== e.open && (b.emit("update:open", n, v), b.emit(n ? "open" : "close", v));
    }, m = Je(), p = Qe(), O = N(() => m.interactor.value);
    Q(O, (n) => p == null ? void 0 : p.setInteractor(n));
    const S = N(() => e.virtualElement || O.value), o = C(), l = mt(e), s = N(() => {
      const { appendTo: n } = e;
      return n === !1 ? O.value : $e(n) ? document.querySelector(n) : n;
    }), c = C();
    if (!y) {
      const n = () => {
        const { value: g } = s;
        if (!g)
          return;
        const f = new Le({
          render() {
            return c.value;
          }
        });
        return f.$mount(), g.appendChild(f.$el), () => {
          var D;
          f.$destroy(), (D = f.$el) == null || D.remove();
        };
      }, { clear: v, reset: u } = He(n);
      Q(s, () => u()), ze(u), Be(v);
    }
    const _ = C();
    a({
      getElements: () => ({
        floating: o.value,
        reference: O.value
      }),
      updatePosition: () => {
        var n;
        return (n = _.value) == null ? void 0 : n.updatePosition();
      },
      getFloatingData: () => {
        var n;
        return (n = _.value) == null ? void 0 : n.getFloatingData();
      }
    });
    const x = (n) => e.gpuAcceleration ? {
      position: n.strategy,
      top: 0,
      left: 0,
      transform: `translate3d(${n.x}px, ${n.y}px, 0px)`,
      zIndex: e.zIndex
    } : {
      position: n.strategy,
      top: `${n.y}px`,
      left: `${n.x}px`,
      zIndex: e.zIndex
    }, F = (n, v) => {
      let u = z("div", {
        data: A(e.floatingProps, {
          ref: o,
          class: ae.floating,
          style: x(n)
        })
      }, [v]);
      if (e.floatingWrapper && (u = e.floatingWrapper(u)), y)
        return d(Se, {
          to: s.value
        }, {
          default: () => [u]
        });
      c.value = u;
    }, W = (n) => {
      var v;
      const { value: u } = $, { destoryedOnClosed: g } = e;
      if (!u && g)
        return;
      const f = z("div", {
        data: A(e.popupProps, {
          class: ae.popup
        })
      }, (v = t.default) == null ? void 0 : v.call(t, n));
      if (y)
        K && K(f, [[Fe, u, "show"]]);
      else {
        const D = {
          name: "show",
          value: u
        };
        (f.data.directives || (f.data.directives = [])).push(D);
      }
      return e.popupWrapper ? e.popupWrapper(f) : f;
    }, Ue = (n) => {
      var v;
      const u = ne(w(w({}, h(e, Object.keys(je))), pt(h(e, Object.keys(xe)))), {
        active: $.value,
        targets: [o.value].filter(qe)
      }), g = {
        "onUpdate:active": i
      }, f = (v = t.reference) == null ? void 0 : v.call(t);
      return y ? d(Y, w(w(w({}, r), u), g), [f, n]) : d(Y, {
        attrs: r,
        props: u,
        on: R(g)
      }, f);
    };
    return () => {
      const n = e.disabled || !$.value && !e.autoUpdateOnClosed, v = {
        ref: _
      }, u = {
        reference: S.value,
        floating: o.value,
        disabled: n,
        placement: e.placement,
        strategy: e.strategy,
        autoUpdate: e.autoUpdate,
        middleware: l.value
      }, g = he.forwards(), f = {
        default: (D) => {
          const Re = W(D), Ve = F(D, Re);
          return Ue(Ve);
        }
      };
      return y ? d(X, w(w(w({}, u), g), v), f) : d(X, ne(w({}, v), {
        props: u,
        on: R(g),
        scopedSlots: f
      }));
    };
  }
});
var bt = Object.defineProperty, ht = Object.defineProperties, jt = Object.getOwnPropertyDescriptors, le = Object.getOwnPropertySymbols, xt = Object.prototype.hasOwnProperty, Dt = Object.prototype.propertyIsEnumerable, ie = (e, t, r) => t in e ? bt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, pe = (e, t) => {
  for (var r in t || (t = {}))
    xt.call(t, r) && ie(e, r, t[r]);
  if (le)
    for (var r of le(t))
      Dt.call(t, r) && ie(e, r, t[r]);
  return e;
}, Et = (e, t) => ht(e, jt(t));
const Ie = q(G, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Te = h(G, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex"
]), Ct = Et(pe(pe({}, Te), Ie.props), {
  title: [String, Function],
  content: [String, Function],
  theme: String,
  size: String,
  transitionProps: [String, Object],
  showArrow: Boolean,
  arrow: Function,
  arrowProps: Object,
  popoverProps: Object,
  contentProps: Object,
  popoverWrapper: Function
}), Ne = "visoning-popover", St = {
  theme: "line",
  size: "meduim",
  transitionProps: Ne,
  showArrow: !0
}, J = H(Ct, St);
var Ft = Object.defineProperty, It = Object.defineProperties, Tt = Object.getOwnPropertyDescriptors, ce = Object.getOwnPropertySymbols, Nt = Object.prototype.hasOwnProperty, At = Object.prototype.propertyIsEnumerable, ue = (e, t, r) => t in e ? Ft(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, E = (e, t) => {
  for (var r in t || (t = {}))
    Nt.call(t, r) && ue(e, r, t[r]);
  if (ce)
    for (var r of ce(t))
      At.call(t, r) && ue(e, r, t[r]);
  return e;
}, de = (e, t) => It(e, Tt(t));
const I = {
  popover: "visoning-popover",
  content: "visoning-popover-content",
  title: "visoning-popover-title",
  arrow: "visoning-popover-arrow",
  dark: "theme-dark"
}, fe = M({
  name: "VisoningPopover",
  inheritAttrs: !1,
  props: J,
  setup(e, { attrs: t, expose: r, slots: a }) {
    const P = C(), $ = ({
      placement: o,
      middlewareData: l
    }) => {
      var s, c, _, j;
      const x = (c = (s = l.arrow) == null ? void 0 : s.y) != null ? c : 0, F = (j = (_ = l.arrow) == null ? void 0 : _.x) != null ? j : 0, W = {
        "--vp-arrow-top": `${x}px`,
        "--vp-arrow-left": `${F}px`
      };
      return o.includes("top") || o.includes("bottom") ? W.left = `${F}px` : W.top = `${x}px`, W;
    }, b = (o) => {
      const l = e.arrow || a.arrow;
      return l ? l(o) : d("div", {
        ref: P,
        class: I.arrow,
        style: $(o)
      });
    }, i = N(() => {
      const o = e.middleware || [];
      return e.showArrow && P.value && o.push(tt({
        element: P.value
      })), o;
    }), m = (o) => {
      const { transitionProps: l } = e;
      if (l) {
        const s = $e(l) ? { name: l } : E({
          name: Ne
        }, l);
        if (y) {
          const c = o;
          o = d(Ce, s, {
            default: () => c
          });
        } else
          o = d("transition", {
            props: s
          }, [o]);
      }
      return e.popoverWrapper ? e.popoverWrapper(o) : o;
    }, p = C();
    r({
      updatePosition: () => {
        var o;
        return (o = p.value) == null ? void 0 : o.updatePosition();
      },
      getFloatingData: () => {
        var o;
        return (o = p.value) == null ? void 0 : o.getFloatingData();
      },
      getElements: () => {
        var o;
        return ((o = p.value) == null ? void 0 : o.getElements()) || {};
      }
    });
    const S = (o) => {
      var l, s, c;
      const _ = (l = e.title) != null ? l : a.title, j = (c = (s = e.content) != null ? s : a.content) != null ? c : a.default, x = k(_) ? _() : _, F = k(j) ? j() : j;
      return z("div", {
        data: A(e.popoverProps, {
          class: [
            I.popover,
            `size-${e.size}`,
            e.theme === "dark" && I.dark
          ],
          "data-placement": o.placement
        })
      }, [
        z("div", {
          data: A(e.contentProps, {
            class: I.content
          })
        }, [
          x && d("div", {
            class: I.title
          }, [x]),
          F
        ]),
        e.showArrow && b(o)
      ]);
    };
    return () => {
      const o = {
        ref: p
      }, l = de(E({}, h(e, Object.keys(Te))), {
        middleware: i.value,
        popupWrapper: m,
        popupProps: A(e.popoverProps, {
          class: I.popover
        })
      }), s = Ie.forwards(), c = {
        reference: a.reference,
        default: S
      };
      return y ? d(se, E(E(E(E({}, t), l), s), o), c) : d(se, de(E({}, o), {
        props: l,
        on: R(s),
        attrs: t,
        scopedSlots: c
      }));
    };
  }
});
var Wt = Object.defineProperty, Ut = Object.defineProperties, Rt = Object.getOwnPropertyDescriptors, ve = Object.getOwnPropertySymbols, Vt = Object.prototype.hasOwnProperty, zt = Object.prototype.propertyIsEnumerable, Pe = (e, t, r) => t in e ? Wt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, _e = (e, t) => {
  for (var r in t || (t = {}))
    Vt.call(t, r) && Pe(e, r, t[r]);
  if (ve)
    for (var r of ve(t))
      zt.call(t, r) && Pe(e, r, t[r]);
  return e;
}, Bt = (e, t) => Ut(e, Rt(t));
const Ae = q(J, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), We = h(J, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex",
  "content",
  "theme",
  "size",
  "transitionProps",
  "showArrow",
  "arrow",
  "arrowProps",
  "contentProps"
]), Lt = Bt(_e(_e({}, We), Ae.props), {
  textAlign: String,
  tooltipProps: Object,
  tooltipWrapper: Function
}), kt = {
  interactions: "hover",
  theme: "drak",
  textAlign: "start",
  allowPointerEnterTarget: !1
}, Kt = H(Lt, kt);
var Mt = Object.defineProperty, qt = Object.defineProperties, Ht = Object.getOwnPropertyDescriptors, me = Object.getOwnPropertySymbols, Gt = Object.prototype.hasOwnProperty, Jt = Object.prototype.propertyIsEnumerable, Oe = (e, t, r) => t in e ? Mt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, T = (e, t) => {
  for (var r in t || (t = {}))
    Gt.call(t, r) && Oe(e, r, t[r]);
  if (me)
    for (var r of me(t))
      Jt.call(t, r) && Oe(e, r, t[r]);
  return e;
}, ge = (e, t) => qt(e, Ht(t));
const we = {
  tooltip: "visoning-tooltip",
  content: "visoning-tooltip-content"
}, tr = M({
  name: "Tooltip",
  inheritAttrs: !1,
  props: Kt,
  setup(e, { attrs: t, slots: r, expose: a }) {
    const P = C();
    a({
      updatePosition: () => {
        var i;
        return (i = P.value) == null ? void 0 : i.updatePosition();
      },
      getFloatingData: () => {
        var i;
        return (i = P.value) == null ? void 0 : i.getFloatingData();
      },
      getElements: () => {
        var i;
        return ((i = P.value) == null ? void 0 : i.getElements()) || {};
      }
    });
    const b = () => {
      var i, m;
      const p = (m = (i = e.content) != null ? i : r.content) != null ? m : r.default;
      return d("div", {
        style: {
          textAlign: e.textAlign
        }
      }, [
        d("span", {
          class: we.content
        }, [k(p) ? p() : p])
      ]);
    };
    return () => {
      const i = {
        ref: P
      }, m = ge(T({}, h(e, Object.keys(We))), {
        popoverProps: A(e.tooltipProps, {
          class: we.tooltip
        }),
        popoverWrapper: e.tooltipWrapper
      }), p = Ae.forwards(), O = {
        reference: r.reference,
        arrow: r.arrow,
        content: b
      };
      return y ? d(fe, T(T(T(T({}, t), m), p), i), O) : d(fe, ge(T({}, i), {
        props: m,
        on: R(p),
        attrs: t,
        scopedSlots: O
      }));
    };
  }
});
export {
  fe as Popover,
  I as PopoverClassNames,
  St as PopoverDefaultProps,
  J as PopoverProps,
  Ct as PopoverPropsType,
  Ne as PopoverTransitionName,
  se as Popup,
  ut as PopupDefaultProps,
  G as PopupProps,
  ct as PopupPropsType,
  tr as Tooltip,
  we as TooltipClassNames,
  kt as TooltipDefaultProps,
  Kt as TooltipProps,
  Lt as TooltipPropsType,
  nr as createInteractorForwardContext,
  ar as useInteractorForwardContext
};
